/**为了方便根据Id获取DOM对象*/
var $dom = function(id){return document.getElementById(id);};
/**为了方便判断某个变量是否还没有定义*/
var $isUndefined = function(a){return typeof(a) == "undefined";};

/**滚屏*/
var currentpos, timer,scrollSD = 100;//默认100
function initialize() {
	timer = setInterval('scrollwindow()', scrollSD);
}
function clr() {
	clearInterval(timer);
}
function scrollwindow() {
	currentpos = document.body.scrollTop;
	window.scroll(0, ++currentpos);
	if (currentpos != document.body.scrollTop)
		clr();
}


//IE控制台支持-只是避免出错。没实际功能
if(typeof(console) == "undefined")
{
	var console = function(){
		this.info = function(msg){};
		this.error = function(msg){};
		this.debug = function(msg){};
	};
	window.console = new console();
}

/***添加cookie*/ 
function addCookie(name,value,path,expires,domain){ 
	var str=name+"="+escape(value); 
	if(expires!="" && typeof(expires) != "undefined"){ 
		var date=new Date(); 
		date.setTime(date.getTime()+expires*24*3600*1000);//expires单位为天 
		str+=";expires="+date.toGMTString(); 
	} 
	if(path!="" && typeof(path) != "undefined"){ 
		str+=";path="+path;//指定可访问cookie的目录 
	} 
	if(domain!=""  && typeof(domain) != "undefined"){ 
		str+=";domain="+domain;//指定可访问cookie的域 
	} 
	document.cookie=str; 
} 

/**取得cookie*/ 
function getCookie(name){ 
	var str=document.cookie.split(";"); 
	for(var i=0;i<str.length;i++){ 
		var str2=str[i].split("="); 
		try
		{
			var sName = str2[0].trim();
			if(sName==name)return unescape(str2[1]); 		
		}catch(e){
			
		}
	} 
};

/**删除cookie*/ 
function deleteCookie(name,path){
	var cval=getCookie(name); 
  if(cval!=null) 
	{
  	var date=new Date(); 
  	date.setTime(date.getTime()-10000);
  	var str = name+"=;expire="+date.toGMTString();
  	if(path != "" && typeof(path) != "undefined")
		{
  		str += "; path=" + path;
		}
  	document.cookie=str;
	}
}


/**快捷键支持*/
document.onkeydown = function() {
	if (event.keyCode == 37){//左方向键
		bef();		
	}else if (event.keyCode == 39){//右方向键
		after();		
	}else if (event.keyCode == 13){//回车键
		list();
	}else if (event.keyCode == 32){//空格键
		currentpos = document.body.scrollTop;
		window.scroll(0, currentpos + 1);
		if (currentpos != document.body.scrollTop){//如果成功向下滚动了
			window.scroll(0, currentpos);//回去原始位置
		}else{//如果没成功向下
			after();//自动进入下一章
		}
	}
};

/**上一章*/
function bef() {
	if (contentIndex > 0) {
		var id = contentIndex;
		document.location = '?id=' + bookId + '&index=' + --id;
	}else{
		alert("没有上一章了");
	}
};

/**下一章*/
function after() {
	if (contentCount - 1 > contentIndex) {
		var id = contentIndex;
		document.location = '?id=' + bookId + '&index=' + ++id;
	}else{
		alert("没有下一章了");
	}
};

/**返回目录*/
function list() {
	document.location = 'list.action?id=' + bookId;
};

/**跳转到原始来源地址*/
function gotoPrimitiveUrl(){
	if(primitiveUrl == null || primitiveUrl.indexOf("http") == -1){
		alert("无法打开原始来源：" + primitiveUrl);
	}else{
		var dom = $dom("primitiveUrl");
		if(dom != null){
			dom.setAttribute("href",primitiveUrl);
			dom.setAttribute("target","_blank");
			dom.click();
		}
	}
}

/**取消超链接功能，并设置显示的文字*/
function CancelContentHref(id,text)
{
	var dom = $dom(id);
	if(dom != null){
		dom.removeAttribute("href");
		dom.innerText = text;
	}
};

/**手机阅读初始特效*/
function phoneRead() {
	var context = $dom('content');
	context.style.width = '100%';
	context.style.fontSize = '16px';
};

/**绑定DOM事件*/
function bindById(id,domEvent,method)
{
	var dom = $dom(id);
	if(dom != null)
	{
		var str = "dom." + domEvent + " = method";
		eval(str);
		return true;
	}
	return false;
}
/**设置 Select 的选择*/
var setOptionSelected = function(selectId,optionalValue)
{
	var dom = $dom(selectId);
	if(dom)
	{
		for(var i = 0 ; i < dom.options.length;i++)
		{
			var o = dom.options[i];
			if(o.value == optionalValue)
			{
				dom.selectedIndex = i;
				break;
			}
		}
	}
};

/**可选项变更并保持到Cookie*/
var optionChangeAddCookie = function(selectDom,cookieName){
	var os = selectDom.selectedOptions;
	if(os && os.length > 0)
	{
		var ov = os[0].value;
		addCookie(cookieName,ov);
		readReSet();
	}
};

/**重新设置阅读设置*/
var readReSet = function(){
	/**如果是手机先特殊对待一次 后续才是自定义设置*/
	if (navigator.userAgent.indexOf('Android') > -1
			|| navigator.userAgent.indexOf('iPhone') > -1) {
		phoneRead();
	}
	
	/**初始化获取上次设置的背景色*/
	var backgroundColor = getCookie("backgroundColor");
	if(backgroundColor)
	{
		setOptionSelected("backgroundColorSet",backgroundColor);
		document.body.style.background = backgroundColor;
	}
	/**初始化字体颜色*/
	var fontColor = getCookie("fontColor");
	if(fontColor)
	{
		setOptionSelected("fontColorSet",fontColor);
		$dom("content").style.color = fontColor;
	}
	

	/**初始化字体大小*/
	var fontSize = getCookie("fontSize");
	if(fontSize)
	{
		setOptionSelected("fontSizeSet",fontSize);
		$dom("content").style.fontSize = fontSize;
	}
	
	/**滚屏速度*/
	var scrollSDTmp = getCookie("scrollSD");
	if(scrollSDTmp)
	{
		scrollSD = scrollSDTmp;
	}
	setOptionSelected("scrollSD",scrollSD);
	
	
	/**初始化字体加粗设置*/
	var fontWeightBold = getCookie("fontWeightBold");
	if(fontWeightBold)
	{
		$dom("content").style.fontWeight = fontWeightBold;
		$dom("fontWeightBold").checked = fontWeightBold === "Bold";
	}
	
	/**顶部选项跟随屏幕显示在最顶部*/
	var thisToTop = getCookie("thisToTop") == "true";
	$dom("readSetBox").className = thisToTop ? "readSetBox" : "";
	$dom("thisToTop").checked = thisToTop;
	$dom("contentProgress").innerText = "(" + (contentIndex - 0 + 1) + " / " + contentCount + ")";
	
};
/**页面载入完毕后的处理*/
var onLoad = function() {
	if(contentIndex == 0)
	{
		CancelContentHref("bef","没有上一章了");
	}
	
	if(contentIndex >= contentCount - 1)
	{		
		CancelContentHref("after","没有下一章了");
	}
	readReSet();
	
	/**绑定事件 - 背景颜色改变*/
	bindById("backgroundColorSet","onchange",function(){
		optionChangeAddCookie(this,"backgroundColor");
	});

	/**绑定事件 - 字体颜色改变*/
	bindById("fontColorSet","onchange",function(){
		optionChangeAddCookie(this,"fontColor");
	});
	
	/**绑定事件 - 字体大小改变*/
	bindById("fontSizeSet","onchange",function(){
		optionChangeAddCookie(this,"fontSize");
	});

	/**绑定事件 - 滚屏速度改变*/
	bindById("scrollSD","onchange",function(){
		optionChangeAddCookie(this,"scrollSD");
		initialize();//立即滚屏
	});
	
	/**绑定事件 - 字体加粗改变 - span*/
	bindById("fontWeightBold2","onclick",function(){
		$dom("fontWeightBold").click();
	});
	/**绑定事件 - 字体加粗改变 - checkBox*/
	bindById("fontWeightBold","onchange",function(){
		addCookie("fontWeightBold", this.checked ? "Bold" : "normal");
		readReSet();
	});
	

	/**绑定事件 - 顶部跟随 - span*/
	bindById("thisToTop2","onclick",function(){
		$dom("thisToTop").click();
	});
	/**绑定事件 - 顶部跟随 - checkBox*/
	bindById("thisToTop","onchange",function(){
		addCookie("thisToTop", this.checked);
		readReSet();
	});
	//setTimeout(onLine,1000);
};

var onLine = function(){
	$.get("/js/read.js",function(){
		setTimeout(onLine,10 * 1000);
	});
};




document.onmousedown = clr;
document.ondblclick = initialize;
window.onload=onLoad;
